//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property strict
//------------------------------------------------------------------

extern int    MagicNumber = 123456;  // Magic number to use for the EA
extern bool   EcnBroker   = false;   // Is your broker ECN/STP type of broker?
extern double LotSize     = 0.1;     // Lot size to use for trading
extern int    Slippage    = 3;       // Slipage to use when opening new orders
extern double StopLoss    = 100;     // Initial stop loss (in pips)
extern double TakeProfit  = 100;     // Initial take profit (in pips)
extern bool   MulOnSame   = false;   // Allow multiple opened and closed orders on a same bar?

//
//
//
//
//

enum enFilterWhat
{
   flt_prc,  // Filter the price
   flt_val,  // Filter the regularized ema
   flt_both  // Filter both
};

//
//
//
//
//

extern string _d01        = "";      // Settings for indicators
extern int    BarToUse    = 1;       // Bar to test (0, for still opened, 1 for first closed, and so on)
extern int                RemaLength             = 14;              // Regularized ema calculation length
extern ENUM_APPLIED_PRICE RemaPrice              = PRICE_CLOSE;     // Regularized ema price to use
extern double             RemaLambda             = 5;               // Regularized ema lambda
extern double             RemaFilter             = 0;               // Regularized ema filter to use for filtering (<=0 - no filtering)
extern int                RemaFilterPeriod       = 0;               // Regularized ema filter period (0<= use ema period)
extern enFilterWhat       RemaFilterOn           = flt_val;         // Regularized ema apply filter to :

//
//
//
//
//

extern string  _d02        = "";                    // General settings
extern bool    DisplayInfo = true;                  // Dislay info
extern string  UniqueID    = "SimpleRegEmaButton";  // Button unique ID
extern int     XPos        = 50;                    // Button x position
extern int     YPos        = 50;                    // Button y position
extern int     XSize       = 450;                   // Button width
extern int     YSize       = 25;                    // Button height
extern ENUM_BASE_CORNER Corner = CORNER_LEFT_LOWER; // Button chart corner
extern color   Tncolor       = clrBlack;            // Text color - normal
extern color   Sncolor       = clrRed;              // Text color - enabled
extern color   Bcolor        = clrSilver;           // Button color
extern color   Dcolor        = clrBlack;            // Button border color


bool dummyResult;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{ 
   if (ObjectFind(UniqueID+":button:")!=0) createButton(UniqueID+":button:",WindowExpertName()); setButtonColor();
   return(0); 
}
void OnDeinit(const int reason)
{ 
   switch(reason)
   {
      case REASON_CHARTCHANGE :
      case REASON_RECOMPILE   :
      case REASON_CLOSE       : break;
      default :
      {
         string lookFor       = UniqueID+":";
         int    lookForLength = StringLen(lookFor);
         for (int i=ObjectsTotal()-1; i>=0; i--)
         {
               string objectName = ObjectName(i);  if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
         }
      }                  
   }
}

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
      if (StringFind(sparam,UniqueID+":button:",0)==0) setButtonColor();
   }
}  

//
//
//
//
//

void setButtonColor()
{
   string lookFor       = UniqueID+":button:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      
      //
      //
      //
      //
      //
      
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         ObjectSet(objectName,OBJPROP_COLOR,Tncolor);
            string caption  = "regularized EMA EA";
            bool   enabledt = IsExpertEnabled();
            bool   enablede = IsTradeAllowed();
            bool   pressed  = ObjectGetInteger(0,objectName,OBJPROP_STATE);

               if ( enabledt && enablede &&  pressed) caption += " - experts enabled - expert allowed to work";
               if (!enabledt)                         caption += " - expert trading disabled";
               if (!enablede)                         caption += " - trading disabled";
               if (enabledt && enablede && pressed)
                  ObjectSet(objectName,OBJPROP_COLOR,Sncolor);
                  ObjectSetString(0,objectName,OBJPROP_TEXT,caption);
      }         
   }
}

void createButton(string name, string caption)
{
   if (ObjectFind(name)!=0)
       ObjectCreate(name,OBJ_BUTTON,0,0,0);
          ObjectSet(name,OBJPROP_CORNER   ,Corner);
          ObjectSet(name,OBJPROP_XDISTANCE,XPos);
          ObjectSet(name,OBJPROP_YDISTANCE,YPos);
          ObjectSet(name,OBJPROP_XSIZE,XSize);
          ObjectSet(name,OBJPROP_YSIZE,YSize);
          ObjectSetText(name,caption,10,"Arial",Tncolor);
              ObjectSet(name,OBJPROP_FONTSIZE,10);
              ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
              ObjectSet(name,OBJPROP_COLOR,Tncolor); 
              ObjectSet(name,OBJPROP_BGCOLOR,Bcolor); 
              ObjectSet(name,OBJPROP_BORDER_COLOR,Dcolor); 
              ObjectSet(name,OBJPROP_HIDDEN,true);
              if (Corner==CORNER_RIGHT_LOWER || Corner==CORNER_RIGHT_UPPER)
                     ObjectSet(name,OBJPROP_XDISTANCE,XPos+XSize);
}

bool checkButton()
{
   if (IsTesting()) return(true);
   string name = UniqueID+":button:";
   if (ObjectFind(name)==0 && ObjectGetInteger(0,name,OBJPROP_COLOR)==Sncolor)   
      return(true);
      return(false);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing 0
#define _doBuy     1
#define _doSell    2
int start()
{
   setButtonColor();
   if (!checkButton()) return(0);
   int doWhat = _doNothing;
      double rema_trend_current  = iCustom(NULL,0,"Regularized ema + alerts 1.2",PERIOD_CURRENT,RemaLength,RemaPrice,RemaLambda,RemaFilter,RemaFilterPeriod,RemaFilterOn,7,BarToUse);
      double rema_trend_previous = iCustom(NULL,0,"Regularized ema + alerts 1.2",PERIOD_CURRENT,RemaLength,RemaPrice,RemaLambda,RemaFilter,RemaFilterPeriod,RemaFilterOn,7,BarToUse+1);
      if (rema_trend_current!=rema_trend_previous)
         if (rema_trend_current==1)
               doWhat = _doBuy;
         else  doWhat = _doSell;
         if (doWhat==_doNothing && !DisplayInfo) return(0);
         
   //
   //
   //
   //
   //
   
   int    openedBuys    = 0;
   int    openedSells   = 0;
   double currentProfit = 0;
   for (int i = OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()      != Symbol())            continue;
      if (OrderMagicNumber() != MagicNumber)         continue;

      //
      //
      //
      //
      //
      
      if (DisplayInfo) currentProfit += OrderProfit()+OrderCommission()+OrderSwap();
         
         //
         //
         //
         //
         //
         
         if (OrderType()==OP_BUY)
            if (doWhat==_doSell)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,CLR_NONE)) openedBuys++; }
            else  openedBuys++;
         if (OrderType()==OP_SELL)
            if (doWhat==_doBuy)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,CLR_NONE)) openedSells++; }
            else  openedSells++;            
   }
   if (DisplayInfo) Comment("Current profit at "+TimeToString(TimeLocal(),TIME_SECONDS)+" : "+DoubleToStr(currentProfit,2)+" "+AccountCurrency()); if (doWhat==_doNothing) return(0);

   //
   //
   //
   //
   //

   if (doWhat!=_doNothing && !MulOnSame)
      {
         for (int i = OrdersHistoryTotal()-1; i>=0; i--)
         {
               if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
               if (OrderSymbol()      != Symbol())             continue;
               if (OrderMagicNumber() != MagicNumber)          continue;
               if (iBarShift(NULL,0,OrderCloseTime())!=0)      continue;
               if (OrderType()==OP_BUY  && doWhat ==_doBuy)  { doWhat = _doNothing; break; }
               if (OrderType()==OP_SELL && doWhat ==_doSell) { doWhat = _doNothing; break; }
         }
      }          
   if (doWhat==_doBuy && openedBuys==0)
      {
         RefreshRates();
         double stopLossBuy   = 0; if (StopLoss>0)   stopLossBuy   = Ask-StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitBuy = 0; if (TakeProfit>0) takeProfitBuy = Ask+TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int ticketb = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,0,0,"",MagicNumber,0,CLR_NONE);
            if (ticketb>-1)
              dummyResult = OrderModify(ticketb,OrderOpenPrice(),stopLossBuy,takeProfitBuy,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,stopLossBuy,takeProfitBuy,"",MagicNumber,0,CLR_NONE);
      }
   if (doWhat==_doSell && openedSells==0)
      {
         RefreshRates();
         double stopLossSell   = 0; if (StopLoss>0)   stopLossSell   = Bid+StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitSell = 0; if (TakeProfit>0) takeProfitSell = Bid-TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int tickets = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,0,0,"",MagicNumber,0,CLR_NONE);
            if (tickets>-1)
              dummyResult = OrderModify(tickets,OrderOpenPrice(),stopLossSell,takeProfitSell,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,stopLossSell,takeProfitSell,"",MagicNumber,0,CLR_NONE);
      }
   return(0);
}